<template lang="pug">

div
  .controls
    button(
      @click="prevYear(13)"
    ) &lt;
    button(
      @click="nextYear(13)"
    ) &gt;
  .yearsWrap
    button(
      v-for="(year, idx) in years"
      :key="year + idx" 
      :class="{'active': isSelectedYear(year.yearNumber)}"
      @click="selectYear(year.yearNumber)"
    ) {{ year.yearNumber }}

div
  .monthsWrap
    button(
      v-for="(month, idx) in monthsName"
      :key="month"
      :class="{'active': isSelectedMonth(idx)}"
      @click="selectMonth(idx)"
    ) {{ month }}

div
  .controls
    button(
      @click="prevMonth(1)"
    ) &lt;
    button(
      @click="nextMonth(1)"
    ) &gt;

  .weekdays 
    .weekday(
      v-for="weekdayName in weekdaysNamesShort"
      :key="weekdayName"
    ) {{ weekdayName }}
  .weekRow(
    v-for="(weekMonth, idx) in weeksMonth"
    :key="idx"
  )
    .weekCall(
      v-for="(dayWeek, idx) in weekMonth"
      :key="idx"
    ) {{ dayWeek }}

div
  .controls
    button(
      @click="prevMonth(1)"
    ) &lt;
    button(
      @click="nextMonth(1)"
    ) &gt;

  .weekdays 
    .weekday(
      v-for="weekdayName in weekdaysNamesShort"
      :key="weekdayName"
    ) {{ weekdayName }}
  .days
    .day(
      v-for="(day, idx) in daysCells"
      :key="idx"
      :class="{ \
        'day-month': day.currentMonth, \
        'day-current': day.currentDay, \
        'day-weekend': day.weekend, \
      }"
    ) {{ day.dayNumber }}
</template>

<script setup lang="ts">
import { computed, ref } from 'vue'

const date = ref(new Date())
const year = computed(() => date.value.getFullYear())
const month = computed(() => date.value.getMonth())
const firstDayMonth = computed(() => new Date(year.value, month.value, 1))
const lastDayMonth = computed(() => new Date(year.value, month.value + 1, 0))

const weeksMonth = computed(() => {
  const weeksMonth = []
  const countWeeksMonth = Math.ceil(lastDayMonth.value.getDate() / 7)
  const startDay = new Date(firstDayMonth.value)
  startDay.setDate(startDay.getDate() - (firstDayMonth.value.getDay() || 6))

  for (let week = 0; week < countWeeksMonth; week++) {
    const daysWeek = []

    for (let day = 0; day < 7; day++) {
      const dayStep = day + 1 + week * 7
      const calendarDay = new Date(startDay)
      calendarDay.setDate(startDay.getDate() + dayStep)
      daysWeek.push(calendarDay.getDate())
    }

    weeksMonth.push(daysWeek)
  }
  return weeksMonth
})

// отдает день недели первого дня месяца по русскому календарю
const firstDayRUWeek = computed(() => {
  return (firstDayMonth.value.getDay() || 7) - 1
})

// REGION: календарь 42 ячейки
const daysCells = computed(() => {
  const daysCells = []
  const fistDayMonth = new Date(firstDayMonth.value)
  // TODO: переписать на уловия после подключения локали
  fistDayMonth.setDate(fistDayMonth.getDate() - (firstDayRUWeek.value || 7))

  for (let i = 0; i < 42; i++, fistDayMonth.setDate(fistDayMonth.getDate() + 1)) {
    daysCells.push({
      dayNumber: fistDayMonth.getDate(),
      currentDay: fistDayMonth.toDateString() === new Date().toDateString(),
      currentMonth: fistDayMonth.getMonth() === month.value,
      weekend: fistDayMonth.getDay() === 0 || fistDayMonth.getDay() === 6
    })
  }

  return daysCells
})
// END REGION: календарь 42 ячейки

const years = computed(() => {
  const years = []
  const currentYear = new Date(date.value)

  currentYear.setFullYear(currentYear.getFullYear() - 4)

  for ( let i = 0; i < 9; i++, currentYear.setFullYear(currentYear.getFullYear() + 1)) {
    years.push({
      yearNumber: currentYear.getFullYear()
    })
  }

  return years
})

function prevYear(yearStep) {
  date.value = new Date(date.value.setFullYear(date.value.getFullYear() - yearStep))
}

function nextYear(yearStep) {
  date.value = new Date(date.value.setFullYear(date.value.getFullYear() + yearStep))
}

function selectYear(yearNumber) {
  date.value = new Date(date.value.setFullYear(yearNumber))
}

function isSelectedYear(yearNumber) {
  return yearNumber === date.value.getFullYear()
}

const weekdaysNamesShort = ['Пн', 'Вт', 'Ср', 'Чт', 'Пт', 'Сб', 'Вс']

function prevMonth(monthStep) {
  date.value = new Date(date.value.setMonth(date.value.getMonth() - monthStep, 1))
}

function nextMonth(monthStep) {
  date.value = new Date(date.value.setMonth(date.value.getMonth() + monthStep, 1))
}

const monthsName = [
  'Январь',
  'Февраль',
  'Март',
  'Апрель',
  'Май',
  'Июнь',
  'Июль',
  'Август',
  'Сентябрь',
  'Октябрь',
  'Ноябрь',
  'Декабрь'
]

function selectMonth(monthIdx) {
  date.value = new Date(date.value.setMonth(monthIdx))
}

function isSelectedMonth(monthIdx) {
  return monthIdx === date.value.getMonth()
}
</script>

<style lang="stylus" scoped>
.yearsWrap,
.monthsWrap
  display grid
  grid-template-columns repeat(3, 1fr)
  margin 20px 0

  & > button

    &.active
      background-color blue
      color #fff

.weekdays,
.days
  display grid
  grid-template-columns repeat(7, 1fr)

.day
  aspect-ratio 1
  background-color #e3e3e3

  &-month
    background-color aqua

  &-weekend
    background-color #c3c3c3

  &-current
    background-color red

.week

  &days,
  &Wrap
    display grid

  &Row
    display grid
    grid-template-columns repeat(7, 1fr)

  &Call
    aspect-ratio 1
    background-color #e3e3e3

    &-month
      background-color aqua

    &-weekend
      background-color #c3c3c3

    &-current
      background-color red
</style>
